/*
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This code is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this code; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.  */

/* Copyright (C) 2002 Ian Zimmerman <itz@speakeasy.org> */

static const char rcsid[] = "$Id: gim_abstract_handler.cc,v 1.3 2002/08/26 19:24:52 itz Exp $ ";

#ifdef __cplusplus

#include "gim_abstract_handler.hh"
#include "gim_init_counter.hh"

extern "C" {
#include <stdio.h>
}

static gim_init_counter cnt;

gim_abstract_handler::gim_abstract_handler()
{
  d.morekeys = 0;
  d.is_fake = 0;
  d.extra_data = this;
}

gim_abstract_handler::~gim_abstract_handler()
{
}

int gim_abstract_handler::event_select(gim_connection* conn)
{
  return gim_event_select(conn->fd, static_handler, &d, getcfun, this);
}

int gim_abstract_handler::was_fake()
{
  return d.is_fake;
}

int gim_abstract_handler::static_handler (struct gim_event_t* p_ev, struct gim_handler_data_t* p_data)
{
  gim_abstract_handler* self = reinterpret_cast<gim_abstract_handler*>(p_data->extra_data);
  return self->object_handler(p_ev);
}

int gim_abstract_handler::char_source()
{
  return getchar();
}

int gim_abstract_handler::getcfun (void* p)
{
  gim_abstract_handler* self = reinterpret_cast<gim_abstract_handler*>(p);
  return self->char_source();
}

gim_handler_data_t*
gim_abstract_handler::get_data_p()
{
  return &d;
}

#endif // __cplusplus
